#pragma once

#include "../utils/utils.h"
#include "../debug/exception.h"

/* cannot_resolve_typename_exception exception class */
class cannot_resolve_typename_exception : public exception_base
{
public:
	cannot_resolve_typename_exception(const std::string& type_name)
	{
		this->m_type_name = type_name;
	}

	virtual std::string to_string(void) const override
	{
		return "Cannot resolve typename of \"" + this->m_type_name + "\" !";
	}

private:
	std::string m_type_name;
};